diff -ruN ccp4srs-old/ccp4srs/ccp4srs_monomer.h ccp4srs/ccp4srs/ccp4srs_monomer.h
--- ccp4srs-old/ccp4srs/ccp4srs_monomer.h	2014-03-24 10:40:19.000000000 -0700
+++ ccp4srs/ccp4srs/ccp4srs_monomer.h	2014-09-09 21:34:12.000000000 -0700
@@ -1,10 +1,10 @@
-//  $Id: ccp4srs_monomer.h, v 1.00 2010/03/11 15:28:14 Eugene Exp $
+//  $Id: ccp4srs_monomer.h $
 //  =================================================================
 //
 //   CCP4 SRS Library: Storage, Retrieval and Search support for
 //   CCP4 ligand data.
 //
-//   Copyright (C) Eugene Krissinel 2010-2011.
+//   Copyright (C) Eugene Krissinel 2010-2013.
 //
 //   This library is free software: you can redistribute it and/or
 //   modify it under the terms of the GNU Lesser General Public
@@ -22,16 +22,16 @@
 //
 //  =================================================================
 //
-//    18.10.11   <--  Date of Last Modification.
+//    03.02.14   <--  Date of Last Modification.
 //                   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 //  -----------------------------------------------------------------
 //
 //  **** Module  :  ccp4srs_monomer  <interface>
 //       ~~~~~~~~~
-//  **** Classes :  CCP4SRSMonomer  - monomer structure
+//  **** Classes :  ccp4srs::Monomer  - monomer structure
 //       ~~~~~~~~~
 //
-//  (C) E. Krissinel 2010-2011
+//  (C) E. Krissinel 2010-2014
 //
 //  =================================================================
 //
@@ -39,9 +39,8 @@
 #ifndef CCP4SRS_MONOMER_H
 #define CCP4SRS_MONOMER_H
 
-#include "mmdb/mmdb_mmcif.h"
-#include "mmdb/mmdb_graph.h"
-#include "mmdb/mmdb_defs.h"
+#include "mmdb2/mmdb_mmcif_.h"
+#include "mmdb2/mmdb_math_graph.h"
 
 #include "ccp4srs_entry.h"
 #include "ccp4srs_bond.h"
@@ -50,148 +49,158 @@
 #include "ccp4srs_chicenter.h"
 #include "ccp4srs_plane.h"
 #include "ccp4srs_tree.h"
+#include "ccp4srs_smiles.h"
+#include "ccp4srs_types.h"
 
-DefineClass(CCP4SRSMonomer)
+namespace ccp4srs  {
 
-class CCP4SRSMonomer : public CCP4SRSEntry  {
+  DefineClass(Monomer);
 
-  public:
-    CCP4SRSMonomer();
-    ~CCP4SRSMonomer();
-
-    virtual int type()  { return CCP4SRSEntry::Monomer; }
-
-    void   reset();  // deletes all data
-
-    inline cpstr ID   ()  { return monID;    }
-    inline cpstr oldID()  { return oldMonID; }
-    void   setOldID   ( cpstr oldID );
-
-    cpstr  chem_name   ();
-    cpstr  chem_type   ();
-    cpstr  chem_formula();
-
-    inline int n_atoms     () { return atoms     .numberOf(); }
-    inline int n_bonds     () { return bonds     .numberOf(); }
-    inline int n_angles    () { return angles    .numberOf(); }
-    inline int n_torsions  () { return torsions  .numberOf(); }
-    inline int n_chicenters() { return chicenters.numberOf(); }
-    inline int n_planes    () { return planes    .numberOf(); }
-
-    inline PCCP4SRSAtom  atom  ( int n ) { return atoms   .at(n); }
-    inline PCCP4SRSBond  bond  ( int n ) { return bonds   .at(n); }
-    inline PCCP4SRSAngle angle ( int n ) { return angles  .at(n); }
-    inline PCCP4SRSPlane plane ( int n ) { return planes  .at(n); }
-    inline PCCP4SRSTree  tree  ()        { return &struct_tree;   }
-    inline PCCP4SRSTorsion torsion ( int n )
-                                         { return torsions.at(n); }
-    inline PCCP4SRSChiCenter chicenter ( int n )
-                                       { return chicenters.at(n); }
-
-    inline void add ( PCCP4SRSAtom  atom    ) { atoms .add(atom ); }
-    inline void add ( PCCP4SRSBond  bond    ) { bonds .add(bond ); }
-    inline void add ( PCCP4SRSAngle angle   ) { angles.add(angle); }
-    inline void add ( PCCP4SRSPlane plane   ) { planes.add(plane); }
-    inline void add ( PCCP4SRSTree  stree   )
-                                        { struct_tree.copy(stree); }
-    inline void add ( PCCP4SRSTorsion torsion )
-                                          { torsions.add(torsion); }
-    inline void add ( PCCP4SRSChiCenter chicenter )
-                                      { chicenters.add(chicenter); }
-
-    inline CCP4SRSContainer<CCP4SRSAtom> *get_atoms()
-                                                { return &atoms;      }
-    inline CCP4SRSContainer<CCP4SRSBond> *get_bonds()
-                                                { return &bonds;      }
-    inline CCP4SRSContainer<CCP4SRSAngle> *get_angles()
-                                                { return &angles;     }
-    inline CCP4SRSContainer<CCP4SRSTorsion> *get_torsions()
-                                                { return &torsions;   }
-    inline CCP4SRSContainer<CCP4SRSChiCenter> *get_chicenters()
-                                                { return &chicenters; }
-    inline CCP4SRSContainer<CCP4SRSPlane> *get_planes()
-                                                { return &planes;     }
-    inline CCP4SRSTree *get_tree() { return &struct_tree; }
-
-    int atom_no   ( cpstr aname );
-    int get_bound ( int  atomNo, cpstr elem, int serNo );
-    int get_bound ( int  atomNo, int n );
-    int get_bound ( cpstr aname, int n );
-
-    int addHydrogens ( PCResidue R );
-
-    //  getAtomNameMatch(..) returns anmatch[i], i=0..nAtoms-1, equal
-    // to j such that name(Atom[i])==name(A[j]). Note that atom names
-    // are similarly aligned and space-padded in MMDB, but not in SRS.
-    // However, the proper alignment is done on fly. If ith atom in
-    // the structue is not found in A, anmatch[i] is set -1.
-    //   If array A contains atoms in different alternative
-    // conformations, the the value of altLoc is interpreted as
-    // follows:
-    //    NULL  - the highest occupancy atom will be taken
-    //            if all occupancies are equal then atom with
-    //            first altLoc taken
-    //    other - atoms with given altLoc are taken. If such
-    //            altLoc is not found, the function does as if
-    //            NULL value for altLoc is given.
-    //   A clean PDB file is anticipated, so that atoms with
-    // alternative conformations are grouped together.
-    //   It is Ok to have NULL pointers in A.
-    void getAtomNameMatch ( PPCAtom A, int nat, pstr altLoc,
-                            ivector anmatch );
-
-    /// \brief Matches atoms in given container with atoms in the
-    ///   monomer by atom names.
-    ///  \param[in] A pointer to atom container
-    ///  \param[out] anmatch allocated integer vector
-    ///         [0..A->numberOf()-1], where the match will be returned:
-    /// \arg \b anmatch[i]>=0 : atom A->at(i) matches anmathch[i]-th
-    ///         atom in the monomer
-    /// \arg \b anmatch[i]<0  : atom A->at(i) does not have a name match
-    ///         in the monomer
-    void getAtomNameMatch ( CCP4SRSContainer<CCP4SRSAtom> *A,
-                            ivector anmatch );
-
-    PCGraph getGraph ( int *retCode );
-
-    void getLeavingAtoms ( int & nLeavingAtoms,
-                           ivector & leavingAtom,
-                           ivector & bondedAtom );
-
-    // Return code:
-    //     CCP4SRS_Ok    success
-    int readFromCIF ( PCMMCIFData mmCIFData, pstr error_desc = NULL );
-
-    PCMMCIFData makeCIF();  // return to be deleted by application
-
-    // service function
-    void merge ( PCCP4SRSMonomer monomer );
-
-  protected:
-    ResName                            monID;
-    ResName                            oldMonID;
-    pstr                               monName;
-    pstr                               monType;
-    pstr                               monFormula;
-    CCP4SRSContainer<CCP4SRSAtom>      atoms;
-    CCP4SRSContainer<CCP4SRSBond>      bonds;
-    CCP4SRSContainer<CCP4SRSAngle>     angles;
-    CCP4SRSContainer<CCP4SRSTorsion>   torsions;
-    CCP4SRSContainer<CCP4SRSChiCenter> chicenters;
-    CCP4SRSContainer<CCP4SRSPlane>     planes;
-    CCP4SRSTree                        struct_tree;
-
-    void  Init();
-
-    void  readMonIDFromCIF ( PCMMCIFLoop   loop );
-    void  readMonIDFromCIF ( PCMMCIFStruct mmCIFStruct );
-    int   readFromCIF_ccp4 ( PCMMCIFData   mmCIFData, pstr error_desc );
-    int   readFromCIF_rcsb ( PCMMCIFData   mmCIFData, pstr error_desc );
-
-    virtual void    write_mem ( PCMemIO memIO, int version );
-    virtual Boolean read_mem  ( PCMemIO memIO, int version,
-                                Boolean * Ok = NULL );
+  class Monomer : public Entry  {
 
-};
+    public:
+      Monomer();
+      ~Monomer();
+
+      virtual int type()  { return Entry::Monomer; }
+
+      void   reset();  // deletes all data
+
+      inline mmdb::cpstr ID   ()  { return monID;    }
+      inline mmdb::cpstr oldID()  { return oldMonID; }
+      void   setOldID   ( mmdb::cpstr oldID );
+
+      mmdb::cpstr  chem_name   ();
+      mmdb::cpstr  chem_type   ();
+      mmdb::cpstr  chem_formula();
+
+      inline int n_atoms     () { return atoms     .numberOf(); }
+      inline int n_bonds     () { return bonds     .numberOf(); }
+      inline int n_angles    () { return angles    .numberOf(); }
+      inline int n_torsions  () { return torsions  .numberOf(); }
+      inline int n_chicenters() { return chicenters.numberOf(); }
+      inline int n_planes    () { return planes    .numberOf(); }
+
+      inline PAtom  atom  ( int n ) { return atoms   .at(n); }
+      inline PBond  bond  ( int n ) { return bonds   .at(n); }
+      inline PAngle angle ( int n ) { return angles  .at(n); }
+      inline PPlane plane ( int n ) { return planes  .at(n); }
+      inline PTree  tree  ()        { return &struct_tree;   }
+      inline PTorsion torsion ( int n )
+                                           { return torsions.at(n); }
+      inline PChiCenter chicenter ( int n )
+                                         { return chicenters.at(n); }
+
+      inline void add ( PAtom  atom    ) { atoms .add(atom ); }
+      inline void add ( PBond  bond    ) { bonds .add(bond ); }
+      inline void add ( PAngle angle   ) { angles.add(angle); }
+      inline void add ( PPlane plane   ) { planes.add(plane); }
+      inline void add ( PTree  stree   ) { struct_tree.copy(stree); }
+      inline void add ( PTorsion torsion )
+                                            { torsions.add(torsion); }
+      inline void add ( PChiCenter chicenter )
+                                        { chicenters.add(chicenter); }
+
+      inline Container<Atom>    *get_atoms   () { return &atoms;      }
+      inline Container<Bond>    *get_bonds   () { return &bonds;      }
+      inline Container<Angle>   *get_angles  () { return &angles;     }
+      inline Container<Torsion> *get_torsions() { return &torsions;   }
+      inline Container<ChiCenter> *get_chicenters() { return &chicenters; }
+      inline Container<Plane>   *get_planes  () { return &planes;     }
+      inline Tree *get_tree() { return &struct_tree; }
+
+      inline Smiles *getACDLabs()  { return &ACDLabs; }
+      inline Smiles *getCACTVS ()  { return &CACTVS;  }
+      inline Smiles *getOpenEye()  { return &OpenEye; }
+      inline Smiles *getInChI  ()  { return &InChI;   }
+
+      int atom_no   ( mmdb::cpstr aname );
+      int get_bound ( int  atomNo, mmdb::cpstr elem, int serNo );
+      int get_bound ( int  atomNo, int n );
+      int get_bound ( mmdb::cpstr aname, int n );
+
+      CCP4SRS_RC addHydrogens ( mmdb::PResidue R );
+
+      //  getAtomNameMatch(..) returns anmatch[i], i=0..nAtoms-1, equal
+      // to j such that name(Atom[i])==name(A[j]). Note that atom names
+      // are similarly aligned and space-padded in MMDB, but not in SRS.
+      // However, the proper alignment is done on fly. If ith atom in
+      // the structue is not found in A, anmatch[i] is set -1.
+      //   If array A contains atoms in different alternative
+      // conformations, the the value of altLoc is interpreted as
+      // follows:
+      //    NULL  - the highest occupancy atom will be taken
+      //            if all occupancies are equal then atom with
+      //            first altLoc taken
+      //    other - atoms with given altLoc are taken. If such
+      //            altLoc is not found, the function does as if
+      //            NULL value for altLoc is given.
+      //   A clean PDB file is anticipated, so that atoms with
+      // alternative conformations are grouped together.
+      //   It is Ok to have NULL pointers in A.
+      void getAtomNameMatch ( mmdb::PPAtom A, int nat, mmdb::pstr altLoc,
+                              mmdb::ivector anmatch );
+
+      /// \brief Matches atoms in given container with atoms in the
+      ///   monomer by atom names.
+      ///  \param[in] A pointer to atom container
+      ///  \param[out] anmatch allocated integer vector
+      ///         [0..A->numberOf()-1], where the match will be returned:
+      /// \arg \b anmatch[i]>=0 : atom A->at(i) matches anmathch[i]-th
+      ///         atom in the monomer
+      /// \arg \b anmatch[i]<0  : atom A->at(i) does not have a name match
+      ///         in the monomer
+      void getAtomNameMatch ( Container<Atom> *A, mmdb::ivector anmatch );
+
+      mmdb::math::PGraph getGraph ( int *retCode );
+
+      void getLeavingAtoms ( int & nLeavingAtoms,
+                             mmdb::ivector & leavingAtom,
+                             mmdb::ivector & bondedAtom );
+
+      // Return code:
+      //     CCP4SRS_Ok    success
+      int readFromCIF ( mmdb::mmcif::PData mmCIFData,
+                        mmdb::pstr error_desc = NULL );
+
+      mmdb::mmcif::PData makeCIF();  // return to be deleted by application
+
+      // service function
+      void merge ( PMonomer monomer );
+
+    protected:
+      mmdb::ResName        monID;
+      mmdb::ResName        oldMonID;
+      mmdb::pstr           monName;
+      mmdb::pstr           monType;
+      mmdb::pstr           monFormula;
+      Container<Atom>      atoms;
+      Container<Bond>      bonds;
+      Container<Angle>     angles;
+      Container<Torsion>   torsions;
+      Container<ChiCenter> chicenters;
+      Container<Plane>     planes;
+      Tree                 struct_tree;
+      Smiles               ACDLabs;
+      Smiles               CACTVS;
+      Smiles               OpenEye;
+      Smiles               InChI;
+
+      void  Init();
+
+      void  readMonIDFromCIF ( mmdb::mmcif::PLoop   loop );
+      void  readMonIDFromCIF ( mmdb::mmcif::PStruct mmCIFStruct );
+      int   readFromCIF_ccp4 ( mmdb::mmcif::PData   mmCIFData,
+                               mmdb::pstr error_desc );
+      int   readFromCIF_rcsb ( mmdb::mmcif::PData   mmCIFData,
+                               mmdb::pstr error_desc );
+
+      virtual void write_mem ( PMemIO memIO, int version );
+      virtual bool read_mem  ( PMemIO memIO, int version,
+                               bool * Ok = NULL );
+
+  };
+
+}  // namespace ccp4srs
 
 #endif // CCP4SRS_MONOMER_H
diff -ruN ccp4srs-old/ccp4srs/ccp4srs_plane.cpp ccp4srs/ccp4srs/ccp4srs_plane.cpp
--- ccp4srs-old/ccp4srs/ccp4srs_plane.cpp	2014-03-24 10:40:19.000000000 -0700
+++ ccp4srs/ccp4srs/ccp4srs_plane.cpp	2014-09-09 21:34:12.000000000 -0700
@@ -1,10 +1,10 @@
-//  $Id: ccp4srs_plane.cpp, v 1.00 2010/03/11 15:28:14 Eugene Exp $
+//  $Id: ccp4srs_plane.cpp $
 //  =================================================================
 //
 //   CCP4 SRS Library: Storage, Retrieval and Search support for
 //   CCP4 ligand data.
 //
-//   Copyright (C) Eugene Krissinel 2010-2011.
+//   Copyright (C) Eugene Krissinel 2010-2013.
 //
 //   This library is free software: you can redistribute it and/or
 //   modify it under the terms of the GNU Lesser General Public
@@ -22,181 +22,181 @@
 //
 //  =================================================================
 //
-//    18.10.11   <--  Date of Last Modification.
+//    18.09.13   <--  Date of Last Modification.
 //                   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 //  -----------------------------------------------------------------
 //
 //  **** Module  :  ccp4srs_plane  <implementation>
 //       ~~~~~~~~~
-//  **** Classes :  CCP4SRSPlane  - plain group of atoms
+//  **** Classes :  ccp4srs::Plane  - plain group of atoms
 //       ~~~~~~~~~
 //
-//  (C) E. Krissinel 2010-2011
+//  (C) E. Krissinel 2010-2013
 //
 //  =================================================================
 //
 
-
-#ifndef __STRING_H
 #include <string.h>
-#endif
 
 #include "ccp4srs_plane.h"
 #include "ccp4srs_defs.h"
 
-CCP4SRSPlane::CCP4SRSPlane()  {
-  plane_id[0] = char(0);
-  n_atoms     = 0;
-  plane_atoms = NULL;
-  dist_esd    = NULL;
-}
-
-CCP4SRSPlane::~CCP4SRSPlane()  {
-  empty();
-}
-
-void CCP4SRSPlane::empty()  {
-  FreeVectorMemory ( plane_atoms,0 );
-  FreeVectorMemory ( dist_esd   ,0 );
-  n_atoms = 0;
-}
-
-
-void CCP4SRSPlane::makeCIFTags ( PCMMCIFLoop mmCIFLoop )  {
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_COMP_ID  );
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_PLANE_ID );
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_ATOM_ID  );
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_DIST_ESD );
-}
-
-int CCP4SRSPlane::readFromCIF ( PCMMCIFLoop mmCIFLoop, int planeNo,
-                             CCP4SRSContainer<CCP4SRSAtom> & atoms )  {
-PlaneID planeId;
-int     i,j,k,n,i1,loop_len;
-int     rc;
-
-  empty();
-
-  rc = 0;
-  loop_len = mmCIFLoop->GetLoopLength();
-  if (loop_len<=0)
-    return CCP4SRSPlane::EmptyLoop;
-
-  i1 = -1;
-  n  = 0;
-  for (i=0;(i<loop_len) && (n<=planeNo);i++)  {
-    mmCIFLoop->CopyString ( plane_id,sizeof(PlaneID)-1,
-                            MMCIF_TAG_PLANE_ID,i,rc );
-    k = -1;
-    for (j=i-1;(j>=0) && (k<0);j--)  {
-      mmCIFLoop->CopyString ( planeId,sizeof(PlaneID)-1,
-                              MMCIF_TAG_PLANE_ID,j,rc );
-      if (!strcmp(plane_id,planeId))
-        k = j;
-    }
-    if (k<0)  {
-      n++;
-      i1 = i;
-    }
+namespace ccp4srs  {
+
+  Plane::Plane()  {
+    plane_id[0] = char(0);
+    n_atoms     = 0;
+    plane_atoms = NULL;
+    dist_esd    = NULL;
   }
 
-  if (n<=planeNo)
-    return CCP4SRSPlane::NoMorePlanes;
+  Plane::~Plane()  {
+    empty();
+  }
+
+  void Plane::empty()  {
+    mmdb::FreeVectorMemory ( plane_atoms,0 );
+    mmdb::FreeVectorMemory ( dist_esd   ,0 );
+    n_atoms = 0;
+  }
 
-  GetVectorMemory ( plane_atoms,loop_len-i1,0 );
-  GetVectorMemory ( dist_esd   ,loop_len-i1,0 );
 
-  for (i=i1;i<loop_len;i++)  {
-    mmCIFLoop->CopyString ( planeId,sizeof(PlaneID)-1,
-                            MMCIF_TAG_PLANE_ID,i,rc );
-    if (!strcmp(planeId,plane_id))  {
-      get_atom_from_cif ( plane_atoms[n_atoms],mmCIFLoop,
-                          MMCIF_TAG_ATOM_ID,i,atoms,rc );
-      mmCIFLoop->CopyReal ( dist_esd[n_atoms],MMCIF_TAG_DIST_ESD,i,rc );
-      n_atoms++;
-    }
+  void Plane::makeCIFTags ( mmdb::mmcif::PLoop mmCIFLoop )  {
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_COMP_ID  );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_PLANE_ID );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_ATOM_ID  );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_DIST_ESD );
   }
 
-  return rc;
+  int Plane::readFromCIF ( mmdb::mmcif::PLoop mmCIFLoop,
+                          int planeNo, Container<Atom> & atoms )  {
+  PlaneID planeId;
+  int     i,j,k,n,i1,loop_len;
+  int     rc;
+
+    empty();
+
+    rc = 0;
+    loop_len = mmCIFLoop->GetLoopLength();
+    if (loop_len<=0)
+      return Plane::EmptyLoop;
+
+    i1 = -1;
+    n  = 0;
+    for (i=0;(i<loop_len) && (n<=planeNo);i++)  {
+      mmCIFLoop->CopyString ( plane_id,sizeof(PlaneID)-1,
+                              MMCIF_TAG_PLANE_ID,i,rc );
+      k = -1;
+      for (j=i-1;(j>=0) && (k<0);j--)  {
+        mmCIFLoop->CopyString ( planeId,sizeof(PlaneID)-1,
+                                MMCIF_TAG_PLANE_ID,j,rc );
+        if (!strcmp(plane_id,planeId))
+          k = j;
+      }
+      if (k<0)  {
+        n++;
+        i1 = i;
+      }
+    }
+
+    if (n<=planeNo)
+      return Plane::NoMorePlanes;
+
+    mmdb::GetVectorMemory ( plane_atoms,loop_len-i1,0 );
+    mmdb::GetVectorMemory ( dist_esd   ,loop_len-i1,0 );
 
-}
+    for (i=i1;i<loop_len;i++)  {
+      mmCIFLoop->CopyString ( planeId,sizeof(PlaneID)-1,
+                              MMCIF_TAG_PLANE_ID,i,rc );
+      if (!strcmp(planeId,plane_id))  {
+        get_atom_from_cif ( plane_atoms[n_atoms],mmCIFLoop,
+                            MMCIF_TAG_ATOM_ID,i,atoms,rc );
+        mmCIFLoop->CopyReal ( dist_esd[n_atoms],MMCIF_TAG_DIST_ESD,i,rc );
+        n_atoms++;
+      }
+    }
 
-/*
-loop_
-_chem_comp_plane_atom.comp_id
-_chem_comp_plane_atom.plane_id
-_chem_comp_plane_atom.atom_id
-_chem_comp_plane_atom.dist_esd
- ATP      plan-1    N9        0.020
-*/
+    return rc;
 
-void CCP4SRSPlane::writeToCIF ( PCMMCIFLoop mmCIFLoop, cpstr monID,
-                             CCP4SRSContainer<CCP4SRSAtom> & atoms )  {
-int i;
-  for (i=0;i<n_atoms;i++)  {
-    mmCIFLoop->AddString ( monID,False     );
-    mmCIFLoop->AddString ( plane_id,False  );
-    add_atom_to_cif      ( mmCIFLoop,plane_atoms[i],atoms );
-    mmCIFLoop->AddReal   ( dist_esd[i],"%10.3f" );
   }
-}
 
+  /*
+  loop_
+  _chem_comp_plane_atom.comp_id
+  _chem_comp_plane_atom.plane_id
+  _chem_comp_plane_atom.atom_id
+  _chem_comp_plane_atom.dist_esd
+   ATP      plan-1    N9        0.020
+  */
+
+  void Plane::writeToCIF ( mmdb::mmcif::PLoop mmCIFLoop,
+                           mmdb::cpstr monID,
+                           Container<Atom> & atoms )  {
+  int i;
+    for (i=0;i<n_atoms;i++)  {
+      mmCIFLoop->AddString ( monID,false     );
+      mmCIFLoop->AddString ( plane_id,false  );
+      add_atom_to_cif      ( mmCIFLoop,plane_atoms[i],atoms );
+      mmCIFLoop->AddReal   ( dist_esd[i],"%10.3f" );
+    }
+  }
 
-void CCP4SRSPlane::copy ( PCCP4SRSPlane plane, ivector anmatch )  {
-int i;
 
-  empty();
+  void Plane::copy ( PPlane plane, mmdb::ivector anmatch )  {
+  int i;
 
-  strcpy ( plane_id,plane->id() );
-  n_atoms = plane->size();
-  if (n_atoms>0)  {
-    GetVectorMemory ( plane_atoms,n_atoms,0 );
-    GetVectorMemory ( dist_esd   ,n_atoms,0 );
-    if (anmatch)  {
-      for (i=0;i<n_atoms;i++)  {
-        plane_atoms[i] = anmatch[plane->atom(i)];
-        dist_esd   [i] = plane->esd  ( i );
-      }
-    } else  {
-      for (i=0;i<n_atoms;i++)  {
-        plane_atoms[i] = plane->atom ( i );
-        dist_esd   [i] = plane->esd  ( i );
+    empty();
+
+    strcpy ( plane_id,plane->id() );
+    n_atoms = plane->size();
+    if (n_atoms>0)  {
+      mmdb::GetVectorMemory ( plane_atoms,n_atoms,0 );
+      mmdb::GetVectorMemory ( dist_esd   ,n_atoms,0 );
+      if (anmatch)  {
+        for (i=0;i<n_atoms;i++)  {
+          plane_atoms[i] = anmatch[plane->atom(i)];
+          dist_esd   [i] = plane->esd  ( i );
+        }
+      } else  {
+        for (i=0;i<n_atoms;i++)  {
+          plane_atoms[i] = plane->atom ( i );
+          dist_esd   [i] = plane->esd  ( i );
+        }
       }
     }
-  }
 
-}
+  }
 
-void  CCP4SRSPlane::write_mem ( PCMemIO memIO, int version )  {
-UNUSED_ARGUMENT(version);
-int  i;
-  memIO->put_line   ( plane_id );
-  memIO->put_ishort ( n_atoms  );
-  for (i=0;i<n_atoms;i++)  {
-    memIO->put_integer ( plane_atoms[i] );
-    memIO->put_float   ( dist_esd   [i] );
-  }
-}
-
-Boolean CCP4SRSPlane::read_mem ( PCMemIO memIO, int version,
-                                 Boolean * Ok )  {
-UNUSED_ARGUMENT(version);
-int     i;
-Boolean success;
-  empty();
-  if (Ok)  success = *Ok;
-     else  success = True;
-  memIO->get_line   ( plane_id,&success );
-  memIO->get_ishort ( n_atoms ,&success );
-  if (n_atoms>0)  {
-    GetVectorMemory ( plane_atoms,n_atoms,0 );
-    GetVectorMemory ( dist_esd   ,n_atoms,0 );
+  void  Plane::write_mem ( PMemIO memIO, int version )  {
+  UNUSED_ARGUMENT(version);
+  int  i;
+    memIO->put_line   ( plane_id );
+    memIO->put_ishort ( n_atoms  );
     for (i=0;i<n_atoms;i++)  {
-      memIO->get_integer ( plane_atoms[i],&success );
-      memIO->get_float   ( dist_esd   [i],&success );
+      memIO->put_integer ( plane_atoms[i] );
+      memIO->put_float   ( dist_esd   [i] );
+    }
+  }
+
+  bool Plane::read_mem ( PMemIO memIO, int version, bool * Ok )  {
+  UNUSED_ARGUMENT(version);
+  int     i;
+  bool success;
+    empty();
+    if (Ok)  success = *Ok;
+       else  success = true;
+    memIO->get_line   ( plane_id,&success );
+    memIO->get_ishort ( n_atoms ,&success );
+    if (n_atoms>0)  {
+      mmdb::GetVectorMemory ( plane_atoms,n_atoms,0 );
+      mmdb::GetVectorMemory ( dist_esd   ,n_atoms,0 );
+      for (i=0;i<n_atoms;i++)  {
+        memIO->get_integer ( plane_atoms[i],&success );
+        memIO->get_float   ( dist_esd   [i],&success );
+      }
     }
+    if (Ok)  *Ok = success;
+    return success;
   }
-  if (Ok)  *Ok = success;
-  return success;
-}
 
+}  // namespace ccp4srs
diff -ruN ccp4srs-old/ccp4srs/ccp4srs_plane.h ccp4srs/ccp4srs/ccp4srs_plane.h
--- ccp4srs-old/ccp4srs/ccp4srs_plane.h	2014-03-24 10:40:19.000000000 -0700
+++ ccp4srs/ccp4srs/ccp4srs_plane.h	2014-09-09 21:34:12.000000000 -0700
@@ -1,10 +1,10 @@
-//  $Id: ccp4srs_plane.h, v 1.00 2010/03/11 15:28:14 Eugene Exp $
+//  $Id: ccp4srs_plane.h $
 //  =================================================================
 //
 //   CCP4 SRS Library: Storage, Retrieval and Search support for
 //   CCP4 ligand data.
 //
-//   Copyright (C) Eugene Krissinel 2010-2011.
+//   Copyright (C) Eugene Krissinel 2010-2013.
 //
 //   This library is free software: you can redistribute it and/or
 //   modify it under the terms of the GNU Lesser General Public
@@ -22,16 +22,16 @@
 //
 //  =================================================================
 //
-//    18.10.11   <--  Date of Last Modification.
+//    18.09.13   <--  Date of Last Modification.
 //                   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 //  -----------------------------------------------------------------
 //
 //  **** Module  :  ccp4srs_plane  <interface>
 //       ~~~~~~~~~
-//  **** Classes :  CCP4SRSPlane  - plain group of atoms
+//  **** Classes :  ccp4srs::Plane  - plain group of atoms
 //       ~~~~~~~~~
 //
-//  (C) E. Krissinel 2010-2011
+//  (C) E. Krissinel 2010-2013
 //
 //  =================================================================
 //
@@ -41,46 +41,49 @@
 
 #include "ccp4srs_atom.h"
 
-DefineClass(CCP4SRSPlane)
+namespace ccp4srs  {
 
-typedef char PlaneID[20];
+  DefineClass(Plane);
 
-class CCP4SRSPlane  {
+  typedef char PlaneID[20];
 
-  public:
+  class Plane  {
 
-    enum { Ok=0,EmptyLoop=-11111,NoMorePlanes=-11112 };
+    public:
 
-    CCP4SRSPlane();
-    virtual ~CCP4SRSPlane();
+      enum { Ok=0,EmptyLoop=-11111,NoMorePlanes=-11112 };
 
-    inline cpstr    id   () { return plane_id;    }
-    inline int      size () { return n_atoms;     }
-    inline ivector  atoms() { return plane_atoms; }
-    inline rvector  esds () { return dist_esd;    }
-    inline int      atom ( int atomNo ) { return plane_atoms[atomNo]; }
-    inline realtype esd  ( int atomNo ) { return dist_esd   [atomNo]; }
+      Plane();
+      virtual ~Plane();
 
-    static void makeCIFTags ( PCMMCIFLoop mmCIFLoop );
-    int  readFromCIF ( PCMMCIFLoop mmCIFLoop, int planeNo,
-                       CCP4SRSContainer<CCP4SRSAtom> & atoms );
-    void writeToCIF  ( PCMMCIFLoop mmCIFLoop, cpstr monID,
-                       CCP4SRSContainer<CCP4SRSAtom> & atoms );
+      inline mmdb::cpstr    id   () { return plane_id;    }
+      inline int            size () { return n_atoms;     }
+      inline mmdb::ivector  atoms() { return plane_atoms; }
+      inline mmdb::rvector  esds () { return dist_esd;    }
+      inline int            atom ( int atomNo ) { return plane_atoms[atomNo]; }
+      inline mmdb::realtype esd  ( int atomNo ) { return dist_esd   [atomNo]; }
 
-    void    write_mem ( PCMemIO memIO, int version );
-    Boolean read_mem  ( PCMemIO memIO, int version,
-                        Boolean * Ok = NULL );
+      static void makeCIFTags ( mmdb::mmcif::PLoop mmCIFLoop );
+      int  readFromCIF ( mmdb::mmcif::PLoop mmCIFLoop, int planeNo,
+                         Container<Atom> & atoms );
+      void writeToCIF  ( mmdb::mmcif::PLoop mmCIFLoop, mmdb::cpstr monID,
+                         Container<Atom> & atoms );
 
-    void copy ( PCCP4SRSPlane plane, ivector anmatch=NULL );
+      void write_mem ( PMemIO memIO, int version );
+      bool read_mem  ( PMemIO memIO, int version, bool * Ok = NULL );
 
-  protected:
-    PlaneID  plane_id;     //!< plane id
-    int      n_atoms;      //!< plane size
-    ivector  plane_atoms;  //!< vector of plain's atom names
-    rvector  dist_esd;     //!< vector of distance esds from the plane
+      void copy ( PPlane plane, mmdb::ivector anmatch=NULL );
 
-    void  empty();
+    protected:
+      PlaneID       plane_id;     //!< plane id
+      int           n_atoms;      //!< plane size
+      mmdb::ivector plane_atoms;  //!< vector of plain's atom names
+      mmdb::rvector dist_esd;     //!< vector of distance esds from the plane
 
-};
+      void  empty();
+
+  };
+
+}  // namespace ccp4srs
 
 #endif // CCP4SRS_PLANE_H
